﻿Imports System.Globalization

Namespace Petzold.Controls
    Public Class EqualsToVisibilityMultiConverter
        Implements IMultiValueConverter
        ' object[0] and object[1] should be of the same type. If they're
        ' equal, Convert returns Visibility.Visible, otherwise Visibility.Hidden

        ' Optional object[2] is a boolean. If true, Convert returns
        ' Visibility.Visible regardless.

        ' Optional string parameter if "true" will reverse sense of
        ' Visibility return values.

        Public Function Convert(ByVal value() As Object, ByVal typeTarget As Type, ByVal param As Object, ByVal culture As CultureInfo) As Object Implements IMultiValueConverter.Convert
            Dim equals As Boolean = value(0) Is value(1)

            If value.Length = 3 Then
                equals = equals Or CBool(value(2))
            End If

            Dim reverse As Boolean = False

            If TypeOf param Is String AndAlso Boolean.TryParse(TryCast(param, String), reverse) AndAlso reverse Then
                Return If(equals, Visibility.Hidden, Visibility.Visible)
            End If

            Return If(equals, Visibility.Visible, Visibility.Hidden)
        End Function
        Public Function ConvertBack(ByVal value As Object, ByVal typeTarget() As Type, ByVal param As Object, ByVal culture As CultureInfo) As Object() Implements IMultiValueConverter.ConvertBack
            Return Nothing
        End Function
    End Class
End Namespace
