﻿Namespace Petzold.Controls
    Partial Public Class TouchDatePicker
        Inherits UserControl
        Private datePresenter As New DatePresenter()

        Public Shared ReadOnly DateTimeProperty As DependencyProperty = DependencyProperty.Register("DateTime", GetType(Date), GetType(TouchDatePicker), New PropertyMetadata(Date.Now))

        Public Sub New()
            InitializeComponent()

            Dim binding As New Binding()
            binding.Source = datePresenter
            binding.Path = New PropertyPath("DateTime", Nothing)
            binding.Mode = BindingMode.TwoWay
            SetBinding(DateTimeProperty, binding)

            DataContext = datePresenter
        End Sub

        Public Property _Date() As Date
            Set(ByVal value As Date)
                SetValue(DateTimeProperty, value)
            End Set
            Get
                Return CDate(GetValue(DateTimeProperty))
            End Get
        End Property

        Private Sub OnWindowedItemsControlIsActiveChanged(ByVal sender As Object, ByVal args As DependencyPropertyChangedEventArgs)
            If CBool(args.NewValue) Then
                monthControl.IsActive = sender Is monthControl
                dayControl.IsActive = sender Is dayControl
                yearControl.IsActive = sender Is yearControl
            End If
        End Sub
    End Class
End Namespace
