﻿Imports System.Collections.Specialized

Namespace Petzold.Controls
    Partial Public Class WindowedItemsControl

        Protected Overrides Sub OnItemsChanged(ByVal args As NotifyCollectionChangedEventArgs)
            InvalidateMeasure()
            SetVerticalOffsetFromSelectedIndex()
            MyBase.OnItemsChanged(args)
        End Sub

        Protected Overrides Sub OnItemsPanelChanged(ByVal oldItemsPanel As ItemsPanelTemplate, ByVal newItemsPanel As ItemsPanelTemplate)
            ' This is not the actual WrappableStackPanel that will be used as the ItemsPanel.
            ' This is another instance, and I use the field only for existence, not reference.
            isWrappableStackPanel = (TryCast(newItemsPanel.LoadContent(), WrappableStackPanel)) IsNot Nothing
            MyBase.OnItemsPanelChanged(oldItemsPanel, newItemsPanel)
        End Sub

        Protected Overrides Function MeasureOverride(ByVal constraint As Size) As Size
            numberItems = Me.Items.Count
            ViewportHeight = constraint.Height
            ExtentHeight = MyBase.MeasureOverride(New Size(constraint.Width, Double.PositiveInfinity)).Height
            SetVerticalOffsetFromSelectedIndex()

            Return MyBase.MeasureOverride(constraint)
        End Function

        Protected Overrides Function ArrangeOverride(ByVal arrangeBounds As Size) As Size
            If isWrappableStackPanel Then
                Return MyBase.ArrangeOverride(arrangeBounds)
            End If

            If Me.VisualChildrenCount > 0 Then
                Dim child As UIElement = TryCast(GetVisualChild(0), UIElement)

                If child IsNot Nothing Then
                    child.Arrange(New Rect(0, -VerticalOffset, arrangeBounds.Width, ExtentHeight))
                End If
            End If
            Return arrangeBounds
        End Function
    End Class
End Namespace
